Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCu.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCu.cpp	(revision 54)
@@ -211,4 +211,13 @@
   m_pcRdCost           = pcEncTop->getRdCost();
   
+#if SVC_EXTENSION
+  m_ppcTEncTop         = pcEncTop->getLayerEnc();
+  for(UInt i=0 ; i< m_uhTotalDepth-1 ; i++)
+  {    
+    m_ppcBestCU[i]->setLayerId(pcEncTop->getLayerId());
+    m_ppcTempCU[i]->setLayerId(pcEncTop->getLayerId());
+  }
+#endif
+  
   m_pcEntropyCoder     = pcEncTop->getEntropyCoder();
   m_pcCavlcCoder       = pcEncTop->getCavlcCoder();
@@ -445,4 +454,15 @@
   if(!bSliceEnd && !bSliceStart && bInsidePicture )
   {
+#if (ENCODER_FAST_MODE)
+    bool testInter = true;
+    if (rpcBestCU->getLayerId() > 0)
+    {
+      if (rpcBestCU->getSlice()->getBaseColPic()->getSlice(0)->getSliceType() == I_SLICE)
+      {
+        testInter = false;
+      }
+
+    }
+#endif
     for (Int iQP=iMinQP; iQP<=iMaxQP; iQP++)
     {
@@ -459,5 +479,9 @@
 
       // do inter modes, SKIP and 2Nx2N
+#if (ENCODER_FAST_MODE == 1)
+      if( rpcBestCU->getSlice()->getSliceType() != I_SLICE && testInter )
+#else
       if( rpcBestCU->getSlice()->getSliceType() != I_SLICE )
+#endif
       {
         // 2Nx2N
@@ -480,4 +504,8 @@
           }
         }
+#if (ENCODER_FAST_MODE == 2)
+        if (testInter)
+        {
+#endif
 
         if(!m_pcEncCfg->getUseEarlySkipDetection())
@@ -493,4 +521,8 @@
           }
         }
+#if (ENCODER_FAST_MODE == 2)
+    }
+#endif
+
       }
 
@@ -531,5 +563,9 @@
 
         // do inter modes, NxN, 2NxN, and Nx2N
+#if (ENCODER_FAST_MODE)
+      if( rpcBestCU->getSlice()->getSliceType() != I_SLICE && testInter )
+#else
         if( rpcBestCU->getSlice()->getSliceType() != I_SLICE )
+#endif
         {
           // 2Nx2N, NxN
@@ -685,8 +721,16 @@
         {
           // speedup for inter frames
+#if (ENCODER_FAST_MODE)
+        if( rpcBestCU->getSlice()->getSliceType() == I_SLICE || 
+          !testInter ||
+          rpcBestCU->getCbf( 0, TEXT_LUMA     ) != 0   ||
+          rpcBestCU->getCbf( 0, TEXT_CHROMA_U ) != 0   ||
+          rpcBestCU->getCbf( 0, TEXT_CHROMA_V ) != 0     ) // avoid very complex intra if it is unlikely
+#else
           if( rpcBestCU->getSlice()->getSliceType() == I_SLICE || 
             rpcBestCU->getCbf( 0, TEXT_LUMA     ) != 0   ||
             rpcBestCU->getCbf( 0, TEXT_CHROMA_U ) != 0   ||
             rpcBestCU->getCbf( 0, TEXT_CHROMA_V ) != 0     ) // avoid very complex intra if it is unlikely
+#endif
           {
             xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
@@ -716,4 +760,20 @@
           }
         }
+#if INTRA_BL
+      if(m_pcPicYuvRecBase)
+      {
+        xCheckRDCostIntraBL( rpcBestCU, rpcTempCU );
+        rpcTempCU->initEstData( uiDepth, iQP );
+      }
+#endif
+
+#if (ENCODER_FAST_MODE)
+        if(pcPic->getLayerId() > 0)
+        { 
+          xCheckRDCostILRUni( rpcBestCU, rpcTempCU); 
+          rpcTempCU->initEstData( uiDepth, iQP );
+       }
+#endif
+
         if (isAddLowestQP && (iQP == lowestQP))
         {
@@ -1150,4 +1210,9 @@
     return;
   }
+#if INTRA_BL
+  m_pcEntropyCoder->encodeIntraBLFlag( pcCU, uiAbsPartIdx );
+  if ( !pcCU->isIntraBL( uiAbsPartIdx ) )
+  {
+#endif
   m_pcEntropyCoder->encodePredMode( pcCU, uiAbsPartIdx );
   
@@ -1168,4 +1233,7 @@
   // prediction Info ( Intra : direction mode, Inter : Mv, reference idx )
   m_pcEntropyCoder->encodePredInfo( pcCU, uiAbsPartIdx );
+#if INTRA_BL
+  }
+#endif
   
   // Encode Coefficients
@@ -1221,5 +1289,9 @@
     for( UInt uiMergeCand = 0; uiMergeCand < numValidMergeCand; ++uiMergeCand )
     {
-      {
+#if REF_IDX_ME_ZEROMV
+      Bool bZeroMVILR = rpcTempCU->xCheckZeroMVILRMerge(uhInterDirNeighbours[uiMergeCand], cMvFieldNeighbours[0 + 2*uiMergeCand], cMvFieldNeighbours[1 + 2*uiMergeCand]);
+      if(bZeroMVILR)
+      {
+#endif
         if(!(uiNoResidual==1 && mergeCandBuffer[uiMergeCand]==1))
         {
@@ -1271,5 +1343,7 @@
     }
     }
+#if REF_IDX_ME_ZEROMV 
    }
+#endif
   }
 
@@ -1377,4 +1451,7 @@
   
   m_pcEntropyCoder->resetBits();
+#if INTRA_BL
+  m_pcEntropyCoder->encodeIntraBLFlag ( rpcTempCU, 0,       true );
+#endif
   if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
   {
@@ -1430,4 +1507,7 @@
 
   m_pcEntropyCoder->resetBits();
+#if INTRA_BL
+  m_pcEntropyCoder->encodeIntraBLFlag ( rpcTempCU, 0,       true );
+#endif
   if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
   {
@@ -1681,3 +1761,58 @@
 }
 #endif
+
+#if INTRA_BL
+Void TEncCu::xCheckRDCostIntraBL( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU )
+{
+  UInt uiDepth = rpcTempCU->getDepth( 0 );
+  rpcTempCU->setSkipFlagSubParts( false, 0, uiDepth ); 
+  rpcTempCU->setPartSizeSubParts( SIZE_2Nx2N, 0, uiDepth );
+  rpcTempCU->setPredModeSubParts( MODE_INTRA_BL, 0, uiDepth );  
+  rpcTempCU->setCUTransquantBypassSubParts( m_pcEncCfg->getCUTransquantBypassFlagValue(), 0, uiDepth );
+
+  m_pcPredSearch->setBaseRecPic( m_pcPicYuvRecBase ); 
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+  rpcTempCU->setDepthSubParts( uiDepth, 0 );
+  //   rpcTempCU->setLumaIntraDirSubParts( DC_IDX, 0, uiDepth );
+  //   rpcTempCU->setChromIntraDirSubParts( DC_IDX, 0, uiDepth );
+  m_ppcPredYuvTemp[uiDepth]->copyFromPicLuma  ( rpcTempCU->getSlice()->getFullPelBaseRec(),  rpcTempCU->getAddr(), rpcTempCU->getZorderIdxInCU(), 0, rpcTempCU->getWidth(0), rpcTempCU->getHeight(0));
+  m_ppcPredYuvTemp[uiDepth]->copyFromPicChroma( rpcTempCU->getSlice()->getFullPelBaseRec(),  rpcTempCU->getAddr(), rpcTempCU->getZorderIdxInCU(), 0, (rpcTempCU->getWidth(0)>>1), (rpcTempCU->getHeight(0)>>1), 0);
+  m_ppcPredYuvTemp[uiDepth]->copyFromPicChroma( rpcTempCU->getSlice()->getFullPelBaseRec(),  rpcTempCU->getAddr(), rpcTempCU->getZorderIdxInCU(), 0, (rpcTempCU->getWidth(0)>>1), (rpcTempCU->getHeight(0)>>1), 1);
+  m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU, m_ppcOrigYuv[uiDepth], m_ppcPredYuvTemp[uiDepth], m_ppcResiYuvTemp[uiDepth], m_ppcResiYuvBest[uiDepth], m_ppcRecoYuvTemp[uiDepth], false );
+  rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
+#else
+
+  m_pcPredSearch->estIntraBLPredQT( rpcTempCU, m_ppcOrigYuv[uiDepth], m_ppcPredYuvTemp[uiDepth], m_ppcResiYuvTemp[uiDepth], m_ppcRecoYuvTemp[uiDepth] );
+
+  m_pcEntropyCoder->resetBits();
+  m_pcEntropyCoder->encodeIntraBLFlag ( rpcTempCU, 0,       true );
+  m_pcEntropyCoder->encodeSkipFlag( rpcTempCU, 0,       true );
+  if ( rpcTempCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+  {
+    m_pcEntropyCoder->encodeCUTransquantBypassFlag( rpcTempCU, 0,          true );
+  }
+
+  // Encode Coefficients
+  Bool bCodeDQP = getdQPFlag();
+  m_pcEntropyCoder->encodeCoeff( rpcTempCU, 0, uiDepth, rpcTempCU->getWidth (0), rpcTempCU->getHeight(0), bCodeDQP );
+  setdQPFlag( bCodeDQP );
+  
+  if( m_bUseSBACRD ) m_pcRDGoOnSbacCoder->store(m_pppcRDSbacCoder[uiDepth][CI_TEMP_BEST]);
+  
+  rpcTempCU->getTotalBits() = m_pcEntropyCoder->getNumberOfWrittenBits();
+  if(m_pcEncCfg->getUseSBACRD())
+  {
+    rpcTempCU->getTotalBins() = ((TEncBinCABAC *)((TEncSbac*)m_pcEntropyCoder->m_pcEntropyCoderIf)->getEncBinIf())->getBinsCoded();
+  }
+  rpcTempCU->getTotalCost() = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
+#endif
+  
+  xCheckDQP( rpcTempCU );
+  xCheckBestMode(rpcBestCU, rpcTempCU, uiDepth);
+}
+#endif
+
+
+
+
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCu.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCu.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCu.h	(revision 54)
@@ -84,8 +84,15 @@
   //  Access channel
   TEncCfg*                m_pcEncCfg;
+#if INTRA_BL
+  TComPicYuv*             m_pcPicYuvRecBase;       ///< reconstructed base layer
+#endif 
   TEncSearch*             m_pcPredSearch;
   TComTrQuant*            m_pcTrQuant;
   TComBitCounter*         m_pcBitCounter;
   TComRdCost*             m_pcRdCost;
+  
+#if SVC_EXTENSION
+  TEncTop**               m_ppcTEncTop;
+#endif
   
   TEncEntropy*            m_pcEntropyCoder;
@@ -124,4 +131,7 @@
   UInt getLCUPredictionSAD() { return m_LCUPredictionSAD; }
 #endif
+#if INTRA_BL 
+  Void  setBaseRecPic       ( TComPicYuv* p ) { m_pcPicYuvRecBase = p; }   
+#endif
 protected:
   Void  finishCU            ( TComDataCU*  pcCU, UInt uiAbsPartIdx,           UInt uiDepth        );
@@ -144,4 +154,10 @@
 #endif
   Void  xCheckRDCostIntra   ( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize  );
+#if INTRA_BL
+  Void  xCheckRDCostIntraBL ( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU  );
+#endif
+#if ENCODER_FAST_MODE
+  Void  xCheckRDCostILRUni  ( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU );
+#endif
   Void  xCheckDQP           ( TComDataCU*  pcCU );
   
@@ -168,4 +184,8 @@
 #endif
 
+#if SVC_EXTENSION
+  TEncTop*   getLayerEnc(UInt LayerId)  {return m_ppcTEncTop[LayerId]; }
+#endif 
+
   Void  xFillPCMBuffer     ( TComDataCU*& pCU, TComYuv* pOrgYuv ); 
 };
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 54)
@@ -166,4 +166,11 @@
   }
 
+#if INTRA_BL
+  if( pcCU->isIntraBL( uiAbsPartIdx ) )
+  {
+    return;
+  }
+#endif
+
   m_pcEntropyCoderIf->codePredMode( pcCU, uiAbsPartIdx );
 }
@@ -244,6 +251,10 @@
     }
   }
+#if INTRA_BL
+    if( pcCU->isIntra(uiAbsPartIdx) && pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_NxN && uiDepth == pcCU->getDepth(uiAbsPartIdx) )
+#else
   
   if( pcCU->getPredictionMode(uiAbsPartIdx) == MODE_INTRA && pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_NxN && uiDepth == pcCU->getDepth(uiAbsPartIdx) )
+#endif
   {
     assert( uiSubdiv );
@@ -331,5 +342,13 @@
     }
     
+#if INTRA_BL
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+    if( ( !pcCU->isIntra( uiAbsPartIdx ) || pcCU->isIntraBL(uiAbsPartIdx)) && uiDepth == pcCU->getDepth( uiAbsPartIdx ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, 0 ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_V, 0 ) )
+#else
+    if( ( !pcCU->isIntra( uiAbsPartIdx ) ) && uiDepth == pcCU->getDepth( uiAbsPartIdx ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, 0 ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_V, 0 ) )
+#endif
+#else
     if( pcCU->getPredictionMode(uiAbsPartIdx) != MODE_INTRA && uiDepth == pcCU->getDepth( uiAbsPartIdx ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, 0 ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_V, 0 ) )
+#endif
     {
       assert( pcCU->getCbf( uiAbsPartIdx, TEXT_LUMA, 0 ) );
@@ -412,4 +431,7 @@
 Void TEncEntropy::encodePredInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
+#if INTRA_BL
+  assert ( !pcCU->isIntraBL( uiAbsPartIdx ) );
+#endif
   if( bRD )
   {
@@ -585,5 +607,9 @@
   UInt uiChromaOffset = uiLumaOffset>>2;
     
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+  if( pcCU->isIntra(uiAbsPartIdx) && !pcCU->isIntraBL(uiAbsPartIdx) )
+#else
   if( pcCU->isIntra(uiAbsPartIdx) )
+#endif
   {
     DTRACE_CABAC_VL( g_nSymbolCounter++ )
@@ -733,3 +759,18 @@
 }
 
+#if INTRA_BL
+Void TEncEntropy::encodeIntraBLFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
+{
+  if( pcCU->getLayerId() == 0 )
+  {
+    return;
+  }
+
+  if( bRD )
+  {
+    uiAbsPartIdx = 0;
+  }
+  m_pcEntropyCoderIf->codeIntraBLFlag( pcCU, uiAbsPartIdx );
+}
+#endif
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncEntropy.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncEntropy.h	(revision 54)
@@ -86,4 +86,7 @@
   virtual Void codeSplitFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
   
+#if INTRA_BL
+  virtual Void codeIntraBLFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
+#endif
   virtual Void codePartSize      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
   virtual Void codePredMode      ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
@@ -161,4 +164,7 @@
   Void encodeMergeFlag    ( TComDataCU* pcCU, UInt uiAbsPartIdx );
   Void encodeMergeIndex   ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
+#if INTRA_BL
+  Void encodeIntraBLFlag  ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
+#endif
   Void encodePredMode          ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
   Void encodePartSize          ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, Bool bRD = false );
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 54)
@@ -97,4 +97,7 @@
   xResetNonNestedSEIPresentFlags();
 #endif
+#if SVC_UPSAMPLING
+  m_pcPredSearch        = NULL;
+#endif
   return;
 }
@@ -106,4 +109,12 @@
 /** Create list to contain pointers to LCU start addresses of slice.
  */
+#if SVC_EXTENSION
+Void  TEncGOP::create( UInt layerId )
+{
+  m_bLongtermTestPictureHasBeenCoded = 0;
+  m_bLongtermTestPictureHasBeenCoded2 = 0;
+  m_layerId = layerId;
+}
+#else
 Void  TEncGOP::create()
 {
@@ -111,4 +122,5 @@
   m_bLongtermTestPictureHasBeenCoded2 = 0;
 }
+#endif
 
 Void  TEncGOP::destroy()
@@ -121,6 +133,5 @@
   m_pcCfg                = pcTEncTop;
   m_pcSliceEncoder       = pcTEncTop->getSliceEncoder();
-  m_pcListPic            = pcTEncTop->getListPic();
-  
+  m_pcListPic            = pcTEncTop->getListPic();  
   m_pcEntropyCoder       = pcTEncTop->getEntropyCoder();
   m_pcCavlcCoder         = pcTEncTop->getCavlcCoder();
@@ -136,4 +147,10 @@
   m_totalCoded         = 0;
 
+#if SVC_EXTENSION
+  m_ppcTEncTop           = pcTEncTop->getLayerEnc();
+#endif
+#if SVC_UPSAMPLING
+  m_pcPredSearch         = pcTEncTop->getPredSearch();                       ///< encoder search class
+#endif
 }
 
@@ -239,5 +256,9 @@
 // Public member functions
 // ====================================================================================================================
+#if SVC_EXTENSION
+Void TEncGOP::compressGOP( Int iPicIdInGOP, Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP)
+#else
 Void TEncGOP::compressGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP)
+#endif
 {
   TComPic*        pcPic;
@@ -261,5 +282,9 @@
   UInt *accumNalsDU = NULL;
   SEIDecodingUnitInfo decodingUnitInfoSEI;
+#if SVC_EXTENSION
+  for ( Int iGOPid=iPicIdInGOP; iGOPid < iPicIdInGOP+1; iGOPid++ )
+#else
   for ( Int iGOPid=0; iGOPid < m_iGopSize; iGOPid++ )
+#endif
   {
     UInt uiColDir = 1;
@@ -337,4 +362,7 @@
     m_pcSliceEncoder->setSliceIdx(0);
     pcPic->setCurrSliceIdx(0);
+#if SVC_EXTENSION
+    pcPic->setLayerId( m_layerId );
+#endif
 
     m_pcSliceEncoder->initEncSlice ( pcPic, iPOCLast, pocCurr, iNumPicRcvd, iGOPid, pcSlice, m_pcEncTop->getSPS(), m_pcEncTop->getPPS() );
@@ -384,4 +412,19 @@
     // Set the nal unit type
     pcSlice->setNalUnitType(getNalUnitType(pocCurr));
+#if REF_IDX_FRAMEWORK
+    if( m_layerId > 0 && (uiPOCCurr % m_pcCfg->getIntraPeriod() == 0) )
+    {
+      pcSlice->setNalUnitType(NAL_UNIT_CODED_SLICE_CRA);
+    }
+    if( m_layerId > 0 && !m_pcEncTop->getElRapSliceTypeB() )
+    {
+      if( (pcSlice->getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA) &&
+          (pcSlice->getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA) &&
+           pcSlice->getSliceType() == B_SLICE )
+      {
+        pcSlice->setSliceType(P_SLICE);
+      }
+    }
+#endif
     if(pcSlice->getNalUnitType()==NAL_UNIT_CODED_SLICE_TRAIL_R)
     {
@@ -470,6 +513,78 @@
 #endif      
 
+#if SVC_EXTENSION      
+      if(m_layerId > 0)
+      {
+        TComList<TComPic*> *cListPic = m_ppcTEncTop[m_layerId-1]->getListPic();
+        pcSlice->setBaseColPic (*cListPic, m_layerId );
+#if SVC_UPSAMPLING
+        if ( pcPic->isSpatialEnhLayer())
+        {    
+          m_pcPredSearch->upsampleBasePic( pcPic->getFullPelBaseRec(), pcSlice->getBaseColPic()->getPicYuvRec(), pcPic->getPicYuvRec() );
+        }
+        else
+        {
+          pcPic->setFullPelBaseRec( pcSlice->getBaseColPic()->getPicYuvRec() );
+        }
+        pcSlice->setFullPelBaseRec ( pcPic->getFullPelBaseRec() );
+#endif
+      }
+#endif 
+
+#if REF_IDX_FRAMEWORK
+    if( pcSlice->getSliceType() == B_SLICE )
+    {
+      pcSlice->setColFromL0Flag(1-uiColDir);
+    }
+#endif
+
     //  Set reference list
     pcSlice->setRefPicList ( rcListPic );
+#if REF_IDX_FRAMEWORK
+    if(m_layerId > 0)
+    {
+      m_pcEncTop->setILRPic(pcPic);
+
+#if REF_IDX_MFM
+      pcSlice->setRefPOCListILP(m_pcEncTop->getIlpList(), pcSlice->getBaseColPic());
+#endif
+      pcSlice->addRefPicList ( m_pcEncTop->getIlpList(), 1);
+
+#if REF_IDX_MFM
+      Bool found         = false;
+      UInt ColFromL0Flag = pcSlice->getColFromL0Flag();
+      UInt ColRefIdx     = pcSlice->getColRefIdx();
+      for(Int colIdx = 0; colIdx < pcSlice->getNumRefIdx( RefPicList(1 - ColFromL0Flag) ); colIdx++) 
+      { 
+        if( pcSlice->getRefPic( RefPicList(1 - ColFromL0Flag), colIdx)->getIsILR() ) 
+        { 
+          ColRefIdx = colIdx; 
+          found = true;
+          break; 
+        }
+      }
+
+      if( found == false )
+      {
+        ColFromL0Flag = 1 - ColFromL0Flag;
+        for(Int colIdx = 0; colIdx < pcSlice->getNumRefIdx( RefPicList(1 - ColFromL0Flag) ); colIdx++) 
+        { 
+          if( pcSlice->getRefPic( RefPicList(1 - ColFromL0Flag), colIdx)->getIsILR() ) 
+          { 
+            ColRefIdx = colIdx; 
+            found = true; 
+            break; 
+          } 
+        }
+      }
+
+      if(found == true)
+      {
+        pcSlice->setColFromL0Flag(ColFromL0Flag);
+        pcSlice->setColRefIdx(ColRefIdx);
+      }
+#endif
+    }
+#endif
 
     //  Slice info. refinement
@@ -493,5 +608,7 @@
     if (pcSlice->getSliceType() == B_SLICE)
     {
+#if !REF_IDX_FRAMEWORK
       pcSlice->setColFromL0Flag(1-uiColDir);
+#endif
       Bool bLowDelay = true;
       Int  iCurrPOC  = pcSlice->getPOC();
@@ -780,4 +897,14 @@
     m_storedStartCUAddrForEncodingSliceSegment.push_back(nextCUAddr);
     startCUAddrSliceSegmentIdx++;
+#if AVC_BASE
+    if( m_layerId == 0 )
+    {
+      pcPic->getPicYuvOrg()->copyToPic( pcPic->getPicYuvRec() );
+#if AVC_SYNTAX
+      pcPic->readBLSyntax( m_ppcTEncTop[0]->getBLSyntaxFile(), SYNTAX_BYTES );
+#endif
+      return;
+    }
+#endif
 
     while(nextCUAddr<uiRealEndAddress) // determine slice boundaries
@@ -878,5 +1005,9 @@
     if ( m_bSeqFirst )
     {
+#if SVC_EXTENSION
+      OutputNALUnit nalu(NAL_UNIT_VPS, 0, m_layerId);
+#else
       OutputNALUnit nalu(NAL_UNIT_VPS);
+#endif
       m_pcEntropyCoder->setBitstream(&nalu.m_Bitstream);
       m_pcEntropyCoder->encodeVPS(m_pcEncTop->getVPS());
@@ -887,5 +1018,9 @@
 #endif
 
+#if SVC_EXTENSION
+      nalu = NALUnit(NAL_UNIT_SPS, 0, m_layerId);
+#else
       nalu = NALUnit(NAL_UNIT_SPS);
+#endif
       m_pcEntropyCoder->setBitstream(&nalu.m_Bitstream);
       if (m_bSeqFirst)
@@ -920,5 +1055,9 @@
 #endif
 
+#if SVC_EXTENSION
+      nalu = NALUnit(NAL_UNIT_PPS, 0, m_layerId);
+#else
       nalu = NALUnit(NAL_UNIT_PPS);
+#endif
       m_pcEntropyCoder->setBitstream(&nalu.m_Bitstream);
       m_pcEntropyCoder->encodePPS(pcSlice->getPPS());
@@ -1174,5 +1313,9 @@
           m_pcEntropyCoder->resetEntropy      ();
           /* start slice NALunit */
+#if SVC_EXTENSION
+          OutputNALUnit nalu( pcSlice->getNalUnitType(), pcSlice->getTLayer(), m_layerId );
+#else
           OutputNALUnit nalu( pcSlice->getNalUnitType(), pcSlice->getTLayer() );
+#endif
           Bool sliceSegment = (!pcSlice->isNextSlice());
           if (!sliceSegment)
@@ -1436,5 +1579,9 @@
           digestStr = digestToString(sei_recon_picture_digest.digest, 4);
         }
+#if SVC_EXTENSION
+        OutputNALUnit nalu(NAL_UNIT_SEI_SUFFIX, pcSlice->getTLayer(), m_layerId);
+#else
         OutputNALUnit nalu(NAL_UNIT_SEI_SUFFIX, pcSlice->getTLayer());
+#endif
 
         /* write the SEI messages */
@@ -1708,7 +1855,12 @@
   if( accumNalsDU != NULL) delete accumNalsDU;
 
+#if SVC_EXTENSION
+  assert ( m_iNumPicCoded <= 1 );
+#else
   assert ( m_iNumPicCoded == iNumPicRcvd );
+#endif
 }
 
+#if !SVC_EXTENSION
 Void TEncGOP::printOutSummary(UInt uiNumAllPicCoded)
 {
@@ -1746,4 +1898,5 @@
   printf("\nRVM: %.3lf\n" , xCalculateRVM());
 }
+#endif
 
 Void TEncGOP::preLoopFilterPicAll( TComPic* pcPic, UInt64& ruiDist, UInt64& ruiBits )
@@ -2020,4 +2173,20 @@
 
   //===== add PSNR =====
+#if SVC_EXTENSION
+  m_gcAnalyzeAll[m_layerId].addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+  TComSlice*  pcSlice = pcPic->getSlice(0);
+  if (pcSlice->isIntra())
+  {
+    m_gcAnalyzeI[m_layerId].addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+  }
+  if (pcSlice->isInterP())
+  {
+    m_gcAnalyzeP[m_layerId].addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+  }
+  if (pcSlice->isInterB())
+  {
+    m_gcAnalyzeB[m_layerId].addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+  }
+#else
   m_gcAnalyzeAll.addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
   TComSlice*  pcSlice = pcPic->getSlice(0);
@@ -2034,8 +2203,29 @@
     m_gcAnalyzeB.addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
   }
+#endif
 
   Char c = (pcSlice->isIntra() ? 'I' : pcSlice->isInterP() ? 'P' : 'B');
   if (!pcSlice->isReferenced()) c += 32;
 
+#if SVC_EXTENSION
+#if ADAPTIVE_QP_SELECTION
+  printf("POC %4d LId: %1d TId: %1d ( %c-SLICE, nQP %d QP %d ) %10d bits",
+         pcSlice->getPOC(),
+         pcSlice->getLayerId(),
+         pcSlice->getTLayer(),
+         c,
+         pcSlice->getSliceQpBase(),
+         pcSlice->getSliceQp(),
+         uibits );
+#else
+  printf("POC %4d LId: %1d TId: %1d ( %c-SLICE, QP %d ) %10d bits",
+         pcSlice->getPOC()-pcSlice->getLastIDR(),
+         pcSlice->getLayerId(),
+         pcSlice->getTLayer(),
+         c,
+         pcSlice->getSliceQp(),
+         uibits );
+#endif
+#else
 #if ADAPTIVE_QP_SELECTION
   printf("POC %4d TId: %1d ( %c-SLICE, nQP %d QP %d ) %10d bits",
@@ -2054,4 +2244,5 @@
          uibits );
 #endif
+#endif
 
   printf(" [Y %6.4lf dB    U %6.4lf dB    V %6.4lf dB]", dYPSNR, dUPSNR, dVPSNR );
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.h	(revision 54)
@@ -83,4 +83,8 @@
   Bool                    m_bFirst;
   
+#if SVC_EXTENSION
+  UInt                    m_layerId;      
+#endif
+
   //  Access channel
   TEncTop*                m_pcEncTop;
@@ -88,4 +92,11 @@
   TEncSlice*              m_pcSliceEncoder;
   TComList<TComPic*>*     m_pcListPic;
+  
+#if SVC_EXTENSION
+  TEncTop**               m_ppcTEncTop;
+#if SVC_UPSAMPLING
+  TEncSearch*             m_pcPredSearch;                       ///< encoder search class
+#endif  
+#endif
   
   TEncEntropy*            m_pcEntropyCoder;
@@ -125,9 +136,17 @@
   virtual ~TEncGOP();
   
+#if SVC_EXTENSION
+  Void  create      ( UInt layerId );
+#else
   Void  create      ();
+#endif
   Void  destroy     ();
   
   Void  init        ( TEncTop* pcTEncTop );
+#if SVC_EXTENSION
+  Void  compressGOP ( Int iPicIdInGOP, Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRec, std::list<AccessUnit>& accessUnitsInGOP );
+#else
   Void  compressGOP ( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRec, std::list<AccessUnit>& accessUnitsInGOP );
+#endif
   Void xWriteTileLocationToSliceHeader (OutputNALUnit& rNalu, TComOutputBitstream*& rpcBitstreamRedirect, TComSlice*& rpcSlice);
 
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncPic.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncPic.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncPic.cpp	(revision 54)
@@ -126,9 +126,20 @@
  * \return Void
  */
+#if SVC_UPSAMPLING
+Void TEncPic::create( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, UInt uiMaxAQDepth,  
+                      Window &conformanceWindow, Window &defaultDisplayWindow, Int *numReorderPics, TComSPS* pcSps, Bool bIsVirtual )
+
+#else
 Void TEncPic::create( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, UInt uiMaxAQDepth,  
                       Window &conformanceWindow, Window &defaultDisplayWindow, Int *numReorderPics, Bool bIsVirtual )
+#endif
 {
+#if SVC_UPSAMPLING
+  TComPic::create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth,  
+                   conformanceWindow, defaultDisplayWindow, numReorderPics, pcSps, bIsVirtual );
+#else
   TComPic::create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth,  
                    conformanceWindow, defaultDisplayWindow, numReorderPics, bIsVirtual );
+#endif
   m_uiMaxAQDepth = uiMaxAQDepth;
   if ( uiMaxAQDepth > 0 )
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncPic.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncPic.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncPic.h	(revision 54)
@@ -41,5 +41,7 @@
 #include "TLibCommon/CommonDef.h"
 #include "TLibCommon/TComPic.h"
-
+#if SVC_UPSAMPLING
+#include "TLibCommon/TComSlice.h"
+#endif
 //! \ingroup TLibEncoder
 //! \{
@@ -103,6 +105,11 @@
   virtual ~TEncPic();
 
+#if SVC_UPSAMPLING
+  Void          create( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, UInt uiMaxAQDepth,   
+                        Window &conformanceWindow, Window &defaultDisplayWindow, Int *numReorderPics, TComSPS* pcSps, Bool bIsVirtual = false );
+#else
   Void          create( Int iWidth, Int iHeight, UInt uiMaxWidth, UInt uiMaxHeight, UInt uiMaxDepth, UInt uiMaxAQDepth,   
                         Window &conformanceWindow, Window &defaultDisplayWindow, Int *numReorderPics, Bool bIsVirtual = false );
+#endif
   virtual Void  destroy();
 
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 54)
@@ -83,4 +83,7 @@
 , m_cTransformSkipSCModel     ( 1,             2,               NUM_TRANSFORMSKIP_FLAG_CTX    , m_contextModels + m_numContextModels, m_numContextModels)
 , m_CUTransquantBypassFlagSCModel( 1,          1,               NUM_CU_TRANSQUANT_BYPASS_FLAG_CTX, m_contextModels + m_numContextModels, m_numContextModels)
+#if INTRA_BL
+, m_cIntraBLPredFlagSCModel   (1,              1,               NUM_INTRA_BL_PRED_CTX         , m_contextModels + m_numContextModels, m_numContextModels)
+#endif
 {
   assert( m_numContextModels <= MAX_NUM_CTX_MOD );
@@ -131,4 +134,7 @@
   m_cCUTransSubdivFlagSCModel.initBuffer ( eSliceType, iQp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
   m_cSaoMergeSCModel.initBuffer      ( eSliceType, iQp, (UChar*)INIT_SAO_MERGE_FLAG );
+#if INTRA_BL
+  m_cIntraBLPredFlagSCModel.initBuffer ( eSliceType, iQp, (UChar*)INIT_INTRA_BL_PRED_FLAG );
+#endif
   m_cSaoTypeIdxSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_SAO_TYPE_IDX );
   m_cTransformSkipSCModel.initBuffer     ( eSliceType, iQp, (UChar*)INIT_TRANSFORMSKIP_FLAG );
@@ -163,4 +169,7 @@
       curCost  = m_cCUSplitFlagSCModel.calcCost       ( curSliceType, qp, (UChar*)INIT_SPLIT_FLAG );
       curCost += m_cCUSkipFlagSCModel.calcCost        ( curSliceType, qp, (UChar*)INIT_SKIP_FLAG );
+#if INTRA_BL
+      curCost += m_cIntraBLPredFlagSCModel.calcCost   ( curSliceType, qp, (UChar*)INIT_INTRA_BL_PRED_FLAG );
+#endif
       curCost += m_cCUMergeFlagExtSCModel.calcCost    ( curSliceType, qp, (UChar*)INIT_MERGE_FLAG_EXT);
       curCost += m_cCUMergeIdxExtSCModel.calcCost     ( curSliceType, qp, (UChar*)INIT_MERGE_IDX_EXT);
@@ -234,4 +243,7 @@
   m_cCUTransSubdivFlagSCModel.initBuffer ( eSliceType, iQp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
   m_cSaoMergeSCModel.initBuffer      ( eSliceType, iQp, (UChar*)INIT_SAO_MERGE_FLAG );
+#if INTRA_BL
+  m_cIntraBLPredFlagSCModel.initBuffer ( eSliceType, iQp, (UChar*)INIT_INTRA_BL_PRED_FLAG );
+#endif
   m_cSaoTypeIdxSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_SAO_TYPE_IDX );
   m_cTransformSkipSCModel.initBuffer     ( eSliceType, iQp, (UChar*)INIT_TRANSFORMSKIP_FLAG );
@@ -416,4 +428,7 @@
 {
   PartSize eSize         = pcCU->getPartitionSize( uiAbsPartIdx );
+#if INTRA_BL
+  assert( !pcCU->isIntraBL( uiAbsPartIdx ) );
+#endif
   if ( pcCU->isIntra( uiAbsPartIdx ) )
   {
@@ -1584,3 +1599,24 @@
   this->xCopyContextsFrom(pScr);
 }
+
+#if INTRA_BL
+/** code intra_bl flag
+ * \param pcCU
+ * \param uiAbsPartIdx 
+ * \returns Void
+ */
+Void TEncSbac::codeIntraBLFlag( TComDataCU* pcCU, UInt uiAbsPartIdx )
+{
+  // get context function is here
+  UInt uiSymbol = pcCU->isIntraBL( uiAbsPartIdx ) ? 1 : 0;
+
+  UInt uiCtxIntraBL = pcCU->getCtxIntraBLFlag( uiAbsPartIdx ) ;
+  m_pcBinIf->encodeBin(uiSymbol, m_cIntraBLPredFlagSCModel.get( 0, 0, uiCtxIntraBL )); 
+
+  DTRACE_CABAC_VL( g_nSymbolCounter++ );
+  DTRACE_CABAC_T( "\tuiSymbol: ");
+  DTRACE_CABAC_V( uiSymbol );
+  DTRACE_CABAC_T( "\n");
+}
+#endif
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSbac.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSbac.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSbac.h	(revision 54)
@@ -134,4 +134,7 @@
   Void codeMVPIdx        ( TComDataCU* pcCU, UInt uiAbsPartIdx, RefPicList eRefList );
   
+#if INTRA_BL
+  Void codeIntraBLFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx );
+#endif
   Void codePartSize      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
   Void codePredMode      ( TComDataCU* pcCU, UInt uiAbsPartIdx );
@@ -204,4 +207,7 @@
   ContextModel3DBuffer m_cTransformSkipSCModel;
   ContextModel3DBuffer m_CUTransquantBypassFlagSCModel;
+#if INTRA_BL
+  ContextModel3DBuffer m_cIntraBLPredFlagSCModel;
+#endif
 };
 
